#include "histogram.h"
#include <vector>
#include "histogram_internal.h"
void find_minmax(const std::vector <double> &numbers, double &min, double &max, bool &res)
{
    if (numbers.size()==0)
    {
        res = true;
        return;
    }
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
}
std::vector<std::size_t> make_histogram(const std::vector<double> &numbers, std::size_t bin_count)
{
    double min, max;
    bool res = false;
    find_minmax(numbers, min, max, res);
    double bin_size = (max - min) / bin_count;
    std::vector <std::size_t> bins (bin_count);

    for (std::size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (std::size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j+1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}
