#include <iostream>
#include <vector>
#include "text.h"

const std::size_t SCREEN_WIDTH = 80;
const std::size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

void
show_histogram_text(const std::vector <std::size_t> &bins)
{
    std::cout<<std::endl;
    std::size_t max_count = bins[0];
    for (std::size_t i = 0; i < bins.size(); i++)
    {
        if (bins[i] > max_count)
        {
            max_count = bins[i];
        }
    }
    if (max_count > MAX_ASTERISK)
    {
        for (std::size_t i = 0; i < bins.size(); i++)
        {
            std::size_t height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
            if (bins[i] < 100)
            {
                std::cout << " ";
                if (bins[i] < 10)
                {
                    std::cout << " ";
                }
            }
            std::cout << bins[i] << "|";
            for (std::size_t j = 0; j < height; j++)
            {
                std::cout << "*";
            }
            std::cout << std::endl;
        }
    }

    else
    {
        for (std::size_t i = 0; i < bins.size(); i++)
        {
            if (bins[i] < 100)
            {
                std::cout << " ";
                if (bins [i] < 10)
                {
                    std::cout << " ";
                }
            }
            std::cout << bins[i] << "|";
            for (std::size_t j = 0; j < bins[i]; j++)
            {
                std::cout << "*";
            }
            std::cout << std::endl;
        }
    }
}
